<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/30/2003 *
 * ===================                          Last change: 11/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : admins_functions.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Functions for the admins extension               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die admins-Erweiterung           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Check ACL for menu combination
function adminsCheckAdminAcl ($action, $what) {
	// If action is login or logout allow allways!
	$default = 'allow';
	if (($action == 'login') || ($action == 'logout')) return true;

	// Default is deny
	$ret = false;

	// Get admin's id
	$adminId = getCurrentAdminId();

	// Get admin's defult access right
	$default = getAdminDefaultAcl($adminId);

	if (!empty($what)) {
		// Check for parent menu:
		// First get it's action value
		$parent_action = getModeAction('admin', $what);

		// Check with this function...
		$parent = adminsCheckAdminAcl($parent_action, '');
	} else {
		// Anything else is true!
		$parent = false;
	}

	// Shall I test for a main or sub menu? (action or what?)
	$acl_mode = 'failed';
	if ((isExtensionInstalledAndNewer('cache', '0.1.2')) && (isset($GLOBALS['cache_array']['admin_acls'])) && (count($GLOBALS['cache_array']['admin_acls']) > 0)) {
		// Lookup in cache
		if ((!empty($action)) && (isset($GLOBALS['cache_array']['admin_acls']['action_menu'][$adminId])) & ($GLOBALS['cache_array']['admin_acls']['action_menu'][$adminId] == $action)) {
			// Main menu line found
			$acl_mode = $GLOBALS['cache_array']['admin_acls']['access_mode'][$adminId];

			// Count cache hits
			incrementStatsEntry('cache_hits');
		} elseif ((!empty($what)) && (isset($GLOBALS['cache_array']['admin_acls']['what_menu'][$adminId])) && ($GLOBALS['cache_array']['admin_acls']['what_menu'][$adminId] == $what)) {
			// Check sub menu
			$acl_mode = $GLOBALS['cache_array']['admin_acls']['access_mode'][$adminId];

			// Count cache hits
			incrementStatsEntry('cache_hits');
		}
	} elseif (!isExtensionActive('cache')) {
		// Old version, so load it from database
		$result = false;
		if (!empty($action)) {
			// Main menu
			$result = SQL_QUERY_ESC("SELECT `access_mode` FROM `{?_MYSQL_PREFIX?}_admins_acls` WHERE `admin_id`=%s AND `action_menu`='%s' LIMIT 1",
				array(bigintval($adminId), $action), __FUNCTION__, __LINE__);
		} elseif (!empty($what)) {
			// Sub menu
			$result = SQL_QUERY_ESC("SELECT `access_mode` FROM `{?_MYSQL_PREFIX?}_admins_acls` WHERE `admin_id`=%s AND `what_menu`='%s' LIMIT 1",
				array(bigintval($adminId), $what), __FUNCTION__, __LINE__);
		}

		// Is an entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Load ACL
			list($acl_mode) = SQL_FETCHROW($result);
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	}

	// Check ACL and (maybe) allow
	//* DEBUG: */ print 'default='.$default.',acl_mode='.$acl_mode.',parent='.intval($parent).'<br />';
	if (($default == 'allow') || (($default == 'deny') && ($acl_mode == 'allow')) || ($parent === true) || (($default == '***') && ($acl_mode == 'failed') && ($parent === false))) {
		// Access is granted
		$ret = true;
	} // END - if

	// Return value
	//* DEBUG: */ outputHtml(__FUNCTION__."[".__LINE__."]:act={$action},wht={$whatOR},default={$default},acl_mode={$acl_mode}<br />");
	return $ret;
}

// Create email link to admins's account
function generateAdminEmailLink ($email, $mod = 'admin') {
	// Is it an email?
	if (strpos($email, '@') !== false) {
		// Create email link
		$result = SQL_QUERY_ESC("SELECT `id`
FROM
	`{?_MYSQL_PREFIX?}_admins`
WHERE
	`email`='%s'
LIMIT 1",
		array($email), __FUNCTION__, __LINE__);

		// Is there an entry?
		if (SQL_NUMROWS($result) == 1) {
			// Load userid
			list($adminId) = SQL_FETCHROW($result);

			// Rewrite email address to contact link
			$email = '{%url=modules.php?module=' . $mod . '&amp;what=admins_contct&amp;admin=' . bigintval($adminId) . '%}';
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	} elseif ((is_int($email)) && ($email > 0)) {
		// Direct id given
		$email = '{%url=modules.php?module=' . $mod . '&amp;what=admins_contct&amp;admin=' . bigintval($email) . '%}';
	}

	// Return rewritten (?) email address
	return $email;
}

// Change a lot admin account
function adminsChangeAdminAccount ($postData, $element = '') {
	// Begin the update
	$cache_update = '0';
	foreach ($postData['login'] as $id => $login) {
		// Secure id number
		$id = bigintval($id);

		// When both passwords match update admin account
		if ((!empty($element)) && (isset($postData[$element]))) {
			// Save this setting
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins` SET `%s`='%s' WHERE `id`=%s LIMIT 1",
				array($element, $postData[$element][$id], $id), __FILE__, __LINE__);

			// Admin account saved
			$message = getMessage('ADMIN_ACCOUNT_SAVED');
		} elseif ($postData['pass1'][$id] == $postData['pass2'][$id]) {
			// Save only when both passwords are the same (also when they are empty)
			$add = ''; $cache_update = 1;

			// Generate hash
			$hash = generateHash($postData['pass1'][$id]);

			// Save password when set
			if (!empty($postData['pass1'][$id])) $add = sprintf(", `password`='%s'", SQL_ESCAPE($hash));

			// Get admin's id
			$adminId = getCurrentAdminId();
			$salt = substr(getAdminHash($adminId), 0, -40);

			// Rewrite cookie when it's own account
			if ($adminId == $id) {
				// Set timeout cookie
				setSession('admin_last', time());

				if ($login != getSession('admin_login')) {
					// Update login cookie
					setSession('admin_login', $login);

					// Update password cookie as well?
					if (!empty($add)) setSession('admin_md5', $hash);
				} elseif (generateHash($postData['pass1'][$id], $salt) != getSession('admin_md5')) {
					// Update password cookie
					setSession('admin_md5', $hash);
				}
			} // END - if

			// Get default ACL from admin to check if we can allow him to change the default ACL
			$default = getAdminDefaultAcl(getCurrentAdminId());

			// Update admin account
			if ($default == 'allow') {
				// Allow changing default ACL
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_admins`
SET
	`login`='%s'".$add.",
	`email`='%s',
	`default_acl`='%s',
	`la_mode`='%s'
WHERE
	`id`=%s
LIMIT 1",
				array(
					$login,
					$postData['email'][$id],
					$postData['mode'][$id],
					$postData['la_mode'][$id],
					$id
				), __FUNCTION__, __LINE__);
			} else {
				// Do not allow it here
				SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_admins`
SET
	`login`='%s'".$add.",
	`email`='%s',
	`la_mode`='%s'
WHERE
	`id`=%s
LIMIT 1",
				array(
					$login,
					$postData['email'][$id],
					$postData['la_mode'][$id],
					$id
				), __FUNCTION__, __LINE__);
			}

			// Admin account saved
			$message = getMessage('ADMIN_ACCOUNT_SAVED');
		} else {
			// Passwords did not match
			$message = getMessage('ADMINS_ERROR_PASS_MISMATCH');
		}
	} // END - foreach

	// Display message
	if (!empty($message)) {
		loadTemplate('admin_settings_saved', false, $message);
	} // END - if

	// Remove cache file
	runFilterChain('post_admin_edited', postRequestArray());
}

// Make admin accounts editable
function adminsEditAdminAccount ($postData) {
	// "Resolve" current's admin access mode
	$currMode = getAdminDefaultAcl(getCurrentAdminId());

	// Begin the edit loop
	$OUT = ''; $SW = 2;
	foreach ($postData['sel'] as $id => $selected) {
		// Secure id number
		$id = bigintval($id);

		// Get the admin's data
		$result = SQL_QUERY_ESC("SELECT `login`, `email`, `default_acl` AS mode, `la_mode` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
			array($id), __FUNCTION__, __LINE__);
		if ((SQL_NUMROWS($result) == 1) && ($selected == 1)) {
			// Entry found
			$content = SQL_FETCHARRAY($result);
			SQL_FREERESULT($result);

			// Prepare some more data for the template
			$content['sw'] = $SW;
			$content['id'] = $id;

			// Shall we allow changing default ACL?
			if ($currMode == 'allow') {
				// Allow chaning it
				$content['mode']    = generateOptionList('/ARRAY/', array('allow', 'deny'), array(getMessage('ADMINS_ALLOW_MODE'), getMessage('ADMINS_DENY_MODE')), $content['mode']);
			} else {
				// Don't allow it
				$content['mode'] = '&nbsp;';
			}
			$content['la_mode'] = generateOptionList('/ARRAY/', array('global', 'OLD', 'NEW'), array(getMessage('ADMINS_GLOBAL_LA_SETTING'), getMessage('ADMINS_OLD_LA_SETTING'), getMessage('ADMINS_NEW_LA_SETTING')), $content['la_mode']);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_edit_admins_row', true, $content);
			$SW = 3 - $SW;
		}
	}

	// Load template
	loadTemplate('admin_edit_admins', false, $OUT);
}

// Delete given admin accounts
function adminsDeleteAdminAccount ($postData) {
	// Check if this account is the last one which cannot be deleted...
	$result_main = SQL_QUERY("SELECT `id` FROM `{?_MYSQL_PREFIX?}_admins`", __FUNCTION__, __LINE__);
	$accounts = SQL_NUMROWS($result_main);
	SQL_FREERESULT($result_main);
	if ($accounts > 1) {
		// Delete accounts
		$OUT = ''; $SW = 2;
		foreach ($postData['sel'] as $id => $selected) {
			// Secure id number
			$id = bigintval($id);

			// Get the admin's data
			$result = SQL_QUERY_ESC("SELECT login, email, default_acl AS mode, la_mode FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
				array($id), __FUNCTION__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found
				$content = SQL_FETCHARRAY($result);
				SQL_FREERESULT($result);
				$content['mode'] = getMessage('ADMINS_'.strtoupper($content['mode']).'_MODE');
				$content['la_mode'] = getMessage('ADMINS_'.strtoupper($content['la_mode']).'_LA_SETTING');

				// Prepare some more data
				$content['sw'] = $SW;
				$content['id'] = $id;

				// Load row template and switch color
				$OUT .= loadTemplate('admin_del_admins_row', true, $content);
				$SW = 3 - $SW;
			}
		}

		// Load template
		loadTemplate('admin_del_admins', false, $OUT);
	} else {
		// Cannot delete last account!
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_ADMINS_CANNOT_DELETE_LAST'));
	}
}

// Remove the given accounts
function adminsRemoveAdminAccount ($postData) {
	// Begin removal
	$cache_update = '0';
	foreach ($postData['sel'] as $id => $del) {
		// Secure id number
		$id = bigintval($id);

		// Delete only when it's not your own account!
		if (($del == 1) && (getCurrentAdminId() != $id)) {
			// Rewrite his tasks to all admins
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_task_system` SET `assigned_admin`=0 WHERE `assigned_admin`=%s",
				array($id), __FUNCTION__, __LINE__);

			// Remove account
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id`=%s LIMIT 1",
				array($id), __FUNCTION__, __LINE__);
		}
	}

	// Remove cache if cache system is activated
	runFilterChain('post_admin_deleted', postRequestArray());
}

// List all admin accounts
function adminsListAdminAccounts() {
	// Select all admin accounts
	$result = SQL_QUERY("SELECT `id`, `login`, `email`, `default_acl` AS mode, `la_mode` FROM `{?_MYSQL_PREFIX?}_admins` ORDER BY `login` ASC", __FUNCTION__, __LINE__);
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Compile some variables
		$content['mode'] = getMessage('ADMINS_'.strtoupper($content['mode']).'_MODE');
		$content['la_mode'] = getMessage('ADMINS_'.strtoupper($content['la_mode']).'_LA_SETTING');

		// Prepare some more data
		$content['sw']         = $SW;
		$content['email_link'] = generateEmailLink($content['id'], 'admins');

		// Load row template and switch color
		$OUT .= loadTemplate('admin_list_admins_row', true, $content);
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);

	// Load template
	loadTemplate('admin_list_admins', false, $OUT);
}

// Filter for adding extra data to the query
function FILTER_ADD_EXTRA_SQL_DATA ($add = '') {
	// Is the admins extension updated? (should be!)
	if (getExtensionVersion('admins') >= '0.3.0') $add .= ', `default_acl` AS def_acl';
	if (getExtensionVersion('admins') >= '0.6.7') $add .= ', `la_mode`';
	if (getExtensionVersion('admins') >= '0.7.2') $add .= ', `login_failures`, UNIX_TIMESTAMP(`last_failure`) AS last_failure';
	if (getExtensionVersion('admins') >= '0.7.3') $add .= ', `expert_settings`, `expert_warning`';

	// Return it
	return $add;
}

// Sends out mail to all administrators
// IMPORTANT: Please use SEND_ADMIN_NOTIFCATION() for now!
function sendAdminsEmails ($subj, $template, $content, $userid) {
	// Trim template name
	$template = trim($template);

	// Load email template
	$message = loadEmailTemplate($template, $content, $userid);

	// Check which admin shall receive this mail
	$result = SQL_QUERY_ESC("SELECT `admin_id` FROM `{?_MYSQL_PREFIX?}_admins_mails` WHERE `mail_template`='%s' ORDER BY `admin_id` ASC",
		array($template), __FUNCTION__, __LINE__);
	if (SQL_NUMROWS($result) == '0') {
		// Create new entry (to all admins)
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_admins_mails` (`admin_id`, `mail_template`) VALUES (0, '%s')",
			array($template), __FUNCTION__, __LINE__);
	} else {
		// Load admin ids...
		// @TODO This can be, somehow, rewritten
		$adminIds = array();
		while ($content = SQL_FETCHARRAY($result)) {
			$adminIds[] = $content['admin_id'];
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Init result
		$result = false;

		// "implode" ids and query string
		$adminId = implode(',', $adminIds);
		if ($adminId == '-1') {
			if (isExtensionActive('events')) {
				// Add line to user events
				EVENTS_ADD_LINE($subj, $message, $userid);
			} else {
				// Log error for debug
				logDebugMessage(__FUNCTION__, __LINE__, sprintf("Extension 'events' missing: tpl=%s,subj=%s,userid=%s",
					$template,
					$subj,
					$userid
				));
			}
		} elseif ($adminId == '0') {
			// Select all email adresses
			$result = SQL_QUERY("SELECT `email` FROM `{?_MYSQL_PREFIX?}_admins` ORDER BY `id` ASC",
				__FUNCTION__, __LINE__);
		} else {
			// If Admin-Id is not "to-all" select
			$result = SQL_QUERY_ESC("SELECT `email` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `id` IN (%s) ORDER BY `id` ASC",
				array($adminId), __FUNCTION__, __LINE__);
		}
	}

	// Load email addresses and send away
	while ($content = SQL_FETCHARRAY($result)) {
		sendEmail($content['email'], $subj, $message);
	} // END - while

	// Free memory
	SQL_FREERESULT($result);
}

// "Getter" for current admin's expert settings
function getAminsExpertSettings () {
	// Default is has not the right
	$data['expert_settings'] = 'N';

	// Get current admin login
	$admin = getAdminLogin(getCurrentAdminId());

	// Lookup settings in cache
	if (isset($GLOBALS['cache_array']['admin']['expert_settings'][$admin])) {
		// Use cache
		$data['expert_settings'] = $GLOBALS['cache_array']['admin']['expert_settings'][$admin];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionInstalled('cache')) {
		// Load from database
		$result = SQL_QUERY_ESC("SELECT `expert_settings` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `login`='%s' LIMIT 1",
			array($admin), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Fetch data
			$data = SQL_FETCHARRAY($result);

			// Set cache
			$GLOBALS['cache_array']['admin']['expert_settings'][$admin] = $data['expert_settings'];
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	}

	// Return the result
	return $data['expert_settings'];
}

// "Getter" for current admin's expert warning (if he wants to see them or not
function getAminsExpertWarning () {
	// Default is has not the right
	$data['expert_warning'] = 'N';

	// Get current admin login
	$admin = getAdminLogin(getCurrentAdminId());

	// Lookup warning in cache
	if (isset($GLOBALS['cache_array']['admin']['expert_warning'][$admin])) {
		// Use cache
		$data['expert_warning'] = $GLOBALS['cache_array']['admin']['expert_warning'][$admin];

		// Update cache hits
		incrementStatsEntry('cache_hits');
	} elseif (!isExtensionInstalled('cache')) {
		// Load from database
		$result = SQL_QUERY_ESC("SELECT `expert_warning` FROM `{?_MYSQL_PREFIX?}_admins` WHERE `login`='%s' LIMIT 1",
			array($admin), __FUNCTION__, __LINE__);

		// Entry found?
		if (SQL_NUMROWS($result) == 1) {
			// Fetch data
			$data = SQL_FETCHARRAY($result);

			// Set cache
			$GLOBALS['cache_array']['admin']['expert_warning'][$admin] = $data['expert_warning'];
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	}

	// Return the result
	return $data['expert_warning'];
}

// [EOF]
?>
